# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

from ska_pst.grpc.lmc import ska_pst_lmc_pb2 as ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2

GRPC_GENERATED_VERSION = '1.67.1'
GRPC_VERSION = grpc.__version__
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    raise RuntimeError(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in ska_pst/grpc/lmc/ska_pst_lmc_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
    )


class PstLmcServiceStub(object):
    """
    Service to expose the local monitoring and control functionality
    of a process.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.connect = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/connect',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionResponse.FromString,
                _registered_method=True)
        self.configure_beam = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/configure_beam',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamResponse.FromString,
                _registered_method=True)
        self.deconfigure_beam = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/deconfigure_beam',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamResponse.FromString,
                _registered_method=True)
        self.get_beam_configuration = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/get_beam_configuration',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationResponse.FromString,
                _registered_method=True)
        self.configure_scan = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/configure_scan',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanResponse.FromString,
                _registered_method=True)
        self.deconfigure_scan = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/deconfigure_scan',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanResponse.FromString,
                _registered_method=True)
        self.get_scan_configuration = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/get_scan_configuration',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationResponse.FromString,
                _registered_method=True)
        self.start_scan = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/start_scan',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanResponse.FromString,
                _registered_method=True)
        self.stop_scan = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/stop_scan',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanResponse.FromString,
                _registered_method=True)
        self.get_state = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/get_state',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateResponse.FromString,
                _registered_method=True)
        self.monitor = channel.unary_stream(
                '/ska.pst.lmc.PstLmcService/monitor',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorResponse.FromString,
                _registered_method=True)
        self.abort = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/abort',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortResponse.FromString,
                _registered_method=True)
        self.reset = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/reset',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetResponse.FromString,
                _registered_method=True)
        self.restart = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/restart',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartResponse.FromString,
                _registered_method=True)
        self.go_to_fault = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/go_to_fault',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultResponse.FromString,
                _registered_method=True)
        self.get_env = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/get_env',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentResponse.FromString,
                _registered_method=True)
        self.set_log_level = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/set_log_level',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelResponse.FromString,
                _registered_method=True)
        self.get_log_level = channel.unary_unary(
                '/ska.pst.lmc.PstLmcService/get_log_level',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelResponse.FromString,
                _registered_method=True)
        self.health_check = channel.unary_stream(
                '/ska.pst.lmc.PstLmcService/health_check',
                request_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckRequest.SerializeToString,
                response_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckResponse.FromString,
                _registered_method=True)


class PstLmcServiceServicer(object):
    """
    Service to expose the local monitoring and control functionality
    of a process.
    """

    def connect(self, request, context):
        """
        Used by a client to try to connect to the remote service.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def configure_beam(self, request, context):
        """
        Used by a client to configure the component with given beam configuration.

        Beam configuration is different to scan configuration as it relates to
        how the beam is configured for bandwidth, number of channels, and calculated
        subbands. Between scans the same beam configuration may be used and this
        allows the system to be reconfigured without the need of tearing down
        the shared memory ringbuffers.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deconfigure_beam(self, request, context):
        """
        Used by a client to release a beam and put the component in an state that
        is not even connected to ring buffers.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_beam_configuration(self, request, context):
        """
        Used by a client to get the current beam configuration for the component.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def configure_scan(self, request, context):
        """
        Used by a client to configure a server to be ready for a scan request
        putting the server in a READY state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deconfigure_scan(self, request, context):
        """
        Used by a client to deconfigure a server and put it back to an IDLE state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_scan_configuration(self, request, context):
        """
        Utility method that can be used to get the current scan configuration for a component.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def start_scan(self, request, context):
        """
        Used by a client to start a scan of the component.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def stop_scan(self, request, context):
        """
        Used by a client to end a scan of the component.

        The StopScanRequest has an end_time parameter that if set
        the service must stop the scan at that exact time. This
        method should block until that time has been reached as
        to allow the LMC to know that scanning has stopped.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_state(self, request, context):
        """
        Used by a client to verify the state of the component.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def monitor(self, request, context):
        """
        Used to monitor a service. The service is expected to
        stream results back and putting the monitor data specific
        to itself in a given sub-message, i.e. SMRB to return
        data in an SmrbMonitorData wrapped in a MonitorResponse.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def abort(self, request, context):
        """
        Used by a client to put the server into the ABORTED state.
        This can affect the configuring and scanning stages and
        the service must end those stages. If monitoring is happening
        due to be in a scanning state then the monitoring should also
        stop as that is only valid for scanning states.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def reset(self, request, context):
        """
        Used by a client to reset the device from ABORTED or FAULT state
        into an IDLE / deconfigured state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def restart(self, request, context):
        """
        Used by a client to reset the device from ABORTED or FAULT state
        into an EMPTY state (i.e. not having any beam configuration).
        Implementations of this can do a logical restart, i.e. make sure
        the the system is deconfigured for scan and then deconfigure it
        for beam, resulting in all resources have been released.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def go_to_fault(self, request, context):
        """
        Used by a client to set the service into a FAULT state. This
        can be due to another part of the logical BEAM being faulty
        and a call to this method from a client it advising the service
        to move to the FAULT state.

        By moving to the FAULT state the service can be reset or
        restarted.

        Implementations of this should stop scanning if there it is
        in a scanning state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_env(self, request, context):
        """*
        Used by a client to get the environmental state for the service.

        The client may call this many times as a form of monitoring.
        Unlike the monitor function, which is for monitoring a scan,
        this method doesn't stream results back as it is a standard
        request and response method.

        Implementations of this should document clearly what they
        provide in the map of values. The default implementation is
        to return an empty map of values.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def set_log_level(self, request, context):
        """*
        Used by a client to set LogLevel of the service.

        The client may call this many times to dynamically change the LogLevel.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def get_log_level(self, request, context):
        """*
        Used by a client to get LogLevel of the service.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def health_check(self, request, context):
        """*
        Used by a client to get health status of the service.

        The service should return a health check at the requested interval
        in the request object.  Clients should ensure that what is returned
        is expected of state as well as the service UUID.

        If the client determines that there has been a restart, it should reconnect
        and get the latest UUID (which should be time based or random), and then restart
        the health check process.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_PstLmcServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'connect': grpc.unary_unary_rpc_method_handler(
                    servicer.connect,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionResponse.SerializeToString,
            ),
            'configure_beam': grpc.unary_unary_rpc_method_handler(
                    servicer.configure_beam,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamResponse.SerializeToString,
            ),
            'deconfigure_beam': grpc.unary_unary_rpc_method_handler(
                    servicer.deconfigure_beam,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamResponse.SerializeToString,
            ),
            'get_beam_configuration': grpc.unary_unary_rpc_method_handler(
                    servicer.get_beam_configuration,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationResponse.SerializeToString,
            ),
            'configure_scan': grpc.unary_unary_rpc_method_handler(
                    servicer.configure_scan,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanResponse.SerializeToString,
            ),
            'deconfigure_scan': grpc.unary_unary_rpc_method_handler(
                    servicer.deconfigure_scan,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanResponse.SerializeToString,
            ),
            'get_scan_configuration': grpc.unary_unary_rpc_method_handler(
                    servicer.get_scan_configuration,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationResponse.SerializeToString,
            ),
            'start_scan': grpc.unary_unary_rpc_method_handler(
                    servicer.start_scan,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanResponse.SerializeToString,
            ),
            'stop_scan': grpc.unary_unary_rpc_method_handler(
                    servicer.stop_scan,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanResponse.SerializeToString,
            ),
            'get_state': grpc.unary_unary_rpc_method_handler(
                    servicer.get_state,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateResponse.SerializeToString,
            ),
            'monitor': grpc.unary_stream_rpc_method_handler(
                    servicer.monitor,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorResponse.SerializeToString,
            ),
            'abort': grpc.unary_unary_rpc_method_handler(
                    servicer.abort,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortResponse.SerializeToString,
            ),
            'reset': grpc.unary_unary_rpc_method_handler(
                    servicer.reset,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetResponse.SerializeToString,
            ),
            'restart': grpc.unary_unary_rpc_method_handler(
                    servicer.restart,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartResponse.SerializeToString,
            ),
            'go_to_fault': grpc.unary_unary_rpc_method_handler(
                    servicer.go_to_fault,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultResponse.SerializeToString,
            ),
            'get_env': grpc.unary_unary_rpc_method_handler(
                    servicer.get_env,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentResponse.SerializeToString,
            ),
            'set_log_level': grpc.unary_unary_rpc_method_handler(
                    servicer.set_log_level,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelResponse.SerializeToString,
            ),
            'get_log_level': grpc.unary_unary_rpc_method_handler(
                    servicer.get_log_level,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelResponse.SerializeToString,
            ),
            'health_check': grpc.unary_stream_rpc_method_handler(
                    servicer.health_check,
                    request_deserializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckRequest.FromString,
                    response_serializer=ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'ska.pst.lmc.PstLmcService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('ska.pst.lmc.PstLmcService', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class PstLmcService(object):
    """
    Service to expose the local monitoring and control functionality
    of a process.
    """

    @staticmethod
    def connect(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/connect',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConnectionResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def configure_beam(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/configure_beam',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureBeamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def deconfigure_beam(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/deconfigure_beam',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureBeamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def get_beam_configuration(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/get_beam_configuration',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetBeamConfigurationResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def configure_scan(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/configure_scan',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ConfigureScanResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def deconfigure_scan(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/deconfigure_scan',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.DeconfigureScanResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def get_scan_configuration(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/get_scan_configuration',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetScanConfigurationResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def start_scan(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/start_scan',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StartScanResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def stop_scan(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/stop_scan',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.StopScanResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def get_state(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/get_state',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetStateResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def monitor(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/monitor',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.MonitorResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def abort(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/abort',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.AbortResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def reset(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/reset',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.ResetResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def restart(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/restart',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.RestartResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def go_to_fault(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/go_to_fault',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GoToFaultResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def get_env(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/get_env',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetEnvironmentResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def set_log_level(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/set_log_level',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.SetLogLevelResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def get_log_level(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/get_log_level',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.GetLogLevelResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def health_check(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/ska.pst.lmc.PstLmcService/health_check',
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckRequest.SerializeToString,
            ska__pst_dot_grpc_dot_lmc_dot_ska__pst__lmc__pb2.HealthCheckResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
